/*
 
Copyright (C) 2006 NTT DATA Corporation
 
This program is free software; you can redistribute it and/or
Modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation, version 2.
 
This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied 
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
PURPOSE.  See the GNU General Public License for more details.
 
*/

package com.clustercontrol.collectiverun.action;

import java.rmi.AccessException;
import java.rmi.RemoteException;
import java.rmi.ServerException;
import java.util.ArrayList;
import java.util.Locale;

import javax.ejb.FinderException;
import javax.naming.NamingException;

import com.clustercontrol.bean.Property;
import com.clustercontrol.collectiverun.ejb.session.CollectiveRunController;
import com.clustercontrol.collectiverun.util.EjbConnectionManager;
import com.clustercontrol.util.PropertyUtil;

/**
 * []饹
 * 
 * Ф[]ޤ
 * 
 * @version 1.0.0
 * @since 1.0.0
 */
public class GetHistoryInfo {

    /**
     * []
     * 
     * @return []
     * @throws AccessException 
     */
    public ArrayList getHistory() throws AccessException {
        CollectiveRunController collectiveRun = EjbConnectionManager
                .getConnectionManager().getCollectiveRunController();

        ArrayList list = null;
        try {
            list = collectiveRun.getHistoryList(Locale.getDefault());
        } catch (RemoteException e) {
			if(e instanceof AccessException){
				// ʤξ
				throw (AccessException) e;
			}
            if (e.getCause() instanceof ServerException) {
                // ٥Ȥɽ礭
                if (e.getCause().getCause() instanceof java.lang.IndexOutOfBoundsException) {
                    throw (IndexOutOfBoundsException) e.getCause().getCause();
                }
            }
        } catch (FinderException e) {
        } catch (NamingException e) {
        }

        return list;
    }

    /**
     * []
     * 
     * @param property
     *            ե륿
     * @return []
     * @throws AccessException 
     */
    public ArrayList getHistory(Property property) throws AccessException {
        PropertyUtil.deletePropertyDefine(property);

        CollectiveRunController collectiveRun = EjbConnectionManager
                .getConnectionManager().getCollectiveRunController();

        ArrayList list = null;
        try {
            list = collectiveRun.getHistoryList(property, Locale.getDefault());
        } catch (RemoteException e) {
			if(e instanceof AccessException){
				// ʤξ
				throw (AccessException) e;
			}
            if (e.getCause() instanceof ServerException) {
                // ٥Ȥɽ礭
                if (e.getCause().getCause() instanceof java.lang.IndexOutOfBoundsException) {
                    throw (IndexOutOfBoundsException) e.getCause().getCause();
                }
            }
        } catch (FinderException e) {
        } catch (NamingException e) {
        }

        return list;
    }
}