#!/bin/sh

#Copyright (C) 2005 NTT DATA Corporation
#
#This program is free software; you can redistribute it and/or
#Modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation, version 2.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
                                                                                                                                                                 

MKDIR_PROC="/bin/mkdir"
CHOWN_PROC="/bin/chown"

##
## i[
##
while [ $# -gt 0 ]
do
  #echo $1
  case $1 in
    -u)
      shift
      user="$1"
      ;;
    -g)
      shift
      group="$1"
      ;;
    -m)
      shift
      mode="-m $1"
      ;;
    *)
      #fBNg
      dirname=$1
      ;;
  esac

  shift

done

##
##@[U̓`FbN
##
if [ ${#user} -eq 0 ] ; then
    echo 'The user is not specified.' 1>&2
    exit 11
fi

##
##@O[v̓`FbN
##
if [ ${#group} -eq 0 ] ; then
    echo 'The group is not specified.' 1>&2
    exit 12
fi

##
## mkdirR}hs
##
echo "$MKDIR_PROC $mode $dirname"
$MKDIR_PROC $mode $dirname
if [ $? -ne 0 ] ; then
    exit 10
fi

##
## chownR}hs
##
if [ ${#user} -ne 0 ] ; then
    ownarg=$user
fi
if [ ${#group} -ne 0 ] ; then
    ownarg=$ownarg:$group
fi
if [ ${#ownarg} -ne 0 ] ; then
    echo "$CHOWN_PROC $ownarg $dirname"
    $CHOWN_PROC $ownarg $dirname
    if [ $? -ne 0 ] ; then
        exit 1
    fi
fi

exit

