/*
 
Copyright (C) 2006 NTT DATA Corporation
 
This program is free software; you can redistribute it and/or
Modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation, version 2.
 
This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied 
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
PURPOSE.  See the GNU General Public License for more details.
 
*/

package com.clustercontrol.jobmanagement.action;

import java.rmi.AccessException;
import java.rmi.RemoteException;
import java.util.Locale;

import org.eclipse.jface.dialogs.MessageDialog;

import com.clustercontrol.bean.Property;
import com.clustercontrol.jobmanagement.ejb.session.JobController;
import com.clustercontrol.jobmanagement.util.EjbConnectionManager;
import com.clustercontrol.util.Messages;

/**
 * ѥץѥƥ饹
 * 
 * Ф饸ѥץѥƥ
 * 
 * @version 1.0.0
 * @since 1.0.0
 */
public class GetJobOperationProperty {

	/**
	 * ѥץѥƥ
	 * 
	 * @param local
	 * @return ѥץѥƥ
	 */
	public Property getStartProperty(String sessionId, String jobId, String facilityId) {
		JobController job = 
			EjbConnectionManager.getConnectionManager().getJobController();
		
		Property property = null;
		try {
			property = job.getStartProperty(sessionId, jobId, facilityId, Locale.getDefault());
		} catch (RemoteException e) {
			if(e instanceof AccessException){
				// ʤξ硢顼ɽ
	            MessageDialog.openInformation(null, Messages.getString("message"),
	                    Messages.getString("message.accesscontrol.16"));
			}
		}
		return property;
	}
	
	/**
	 * ѥץѥƥ
	 * 
	 * @param local
	 * @return ѥץѥƥ
	 */
	public Property getStopProperty(String sessionId, String jobId, String facilityId) {
		JobController job = 
			EjbConnectionManager.getConnectionManager().getJobController();
		
		Property property = null;
		try {
			property = job.getStopProperty(sessionId, jobId, facilityId, Locale.getDefault());
		} catch (RemoteException e) {
		}
		return property;
	}
}
