/*
 
Copyright (C) 2006 NTT DATA Corporation
 
This program is free software; you can redistribute it and/or
Modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation, version 2.
 
This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied 
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
PURPOSE.  See the GNU General Public License for more details.
 
*/

package com.clustercontrol.monitor.factory;

import java.util.ArrayList;
import java.util.List;

import javax.ejb.FinderException;
import javax.ejb.RemoveException;
import javax.naming.NamingException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.clustercontrol.monitor.bean.StatusTabelDefine;
import com.clustercontrol.monitor.ejb.entity.StatusInfoLocal;
import com.clustercontrol.monitor.ejb.entity.StatusInfoPK;
import com.clustercontrol.monitor.ejb.entity.StatusInfoUtil;
import com.clustercontrol.util.apllog.AplLogger;


/**
 * ơ륯饹Ǥ
 *
 * @version 2.0.0
 * @since 2.0.0
 */
public class DeleteStatus {
	
	protected static Log m_log = LogFactory.getLog( DeleteStatus.class );
	
	/**
	 * ꤷơޤ
	 * 
	 * @param list оݤΥꥹ
	 * @throws NamingException
	 * @throws FinderException
	 * @throws RemoveException
	 */
	public boolean delete(List list) throws NamingException, FinderException, RemoveException {
		
		if (list != null && list.size()>0) {
			
			ArrayList info = null;
			for(int index=0; index<list.size(); index++){
				
				info = (ArrayList)list.get(index);
				if (info != null && info.size()>0) {
					this.delete((String) info.get(StatusTabelDefine.MONITOR_ID),
							(String) info.get(StatusTabelDefine.PLUGIN_ID),
							(String) info.get(StatusTabelDefine.FACILITY_ID)
							);
				}
			}
		}
		return true;
	}
	
	/**
	 * ꤷơޤ
	 * 
	 * @param monitorId оݤδƻID
	 * @param pluginId оݤΥץ饰ID
	 * @param facilityId оݤΥեƥID
	 * @throws NamingException
	 * @throws FinderException
	 * @throws RemoveException
	 */
	public void delete(String monitorId,
			String pluginId,
			String facilityId
			) throws NamingException, FinderException, RemoveException {
		 
		try
		{
			// ơ
			StatusInfoPK pk = new StatusInfoPK(monitorId,
					pluginId,
					facilityId);
			StatusInfoLocal status = StatusInfoUtil.getLocalHome().findByPrimaryKey(pk);
			
			status.remove();
			
		} catch (FinderException e) {
            AplLogger apllog = new AplLogger("MON", "mon");
            String[] args = {facilityId, monitorId, pluginId};
            apllog.put("SYS", "004", args);
			m_log.debug("modifyConfirm():" + e.getMessage());
			throw e;
		} catch (RemoveException e) {
            AplLogger apllog = new AplLogger("MON", "mon");
            String[] args = {facilityId, monitorId, pluginId};
            apllog.put("SYS", "004", args);
			m_log.debug("modifyConfirm():" + e.getMessage());
			throw e;
		} catch (NamingException e) {
            AplLogger apllog = new AplLogger("MON", "mon");
            String[] args = {facilityId, monitorId, pluginId};
            apllog.put("SYS", "004", args);
			m_log.debug("modifyConfirm():" + e.getMessage());
			throw e;
		}
	}
}

