/*
                                                                                                
Copyright (C) 2006 NTT DATA Corporation
 
This program is free software; you can redistribute it and/or
Modify it under the terms of the GNU General Public License
as published by the Free Software Foundation, version 2.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
*/

package com.clustercontrol.snmppoller;

import java.io.Serializable;
import java.net.InetAddress;

/**
 * SNMPΥݡ󥰤ɬפݻ륯饹
 * 
 * @version 2.0.0
 * @since 2.0.0
 */
public class SnmpConfig implements Serializable {
	private InetAddress address;
	private int port = -1;
	private int version = 1;
	private String comunity = "public";
	private int retries = -1;
	private int timeout = 1000;
	
	/**
	 *  󥹥ȥ饯
	 * @param address IPɥ쥹
	 */
	public SnmpConfig(InetAddress address){
		this.address = address;
	}

	/**
	 * IPɥ쥹֤ޤ
	 * @return IPɥ쥹
	 */
	public InetAddress getAddress() {
		return address;
	}

	/**
	 * IPɥ쥹ꤷޤ
	 * @param address IPɥ쥹
	 */
	public void setAddress(InetAddress address) {
		this.address = address;
	}

	/**
	 * ߥ˥ƥ֤̾ޤ
	 * @return ߥ˥ƥ̾
	 */
	public String getComunity() {
		return comunity;
	}

	/**
	 * ߥ˥ƥ̾ꤷޤ
	 * @param comunity ߥ˥ƥ̾
	 */
	public void setComunity(String comunity) {
		this.comunity = comunity;
	}

	/**
	 * ݡֹ֤ޤ
	 * @return ݡֹ
	 */
	public int getPort() {
		return port;
	}

	/**
	 * ݡֹꤷޤ
	 * @param port ݡֹ
	 */
	public void setPort(int port) {
		this.port = port;
	}

	/**
	 * ȥ饤֤ޤ
	 * @return ȥ饤
	 */
	public int getRetries() {
		return retries;
	}

	/**
	 * ȥ饤ꤷޤ
	 * @param retries ȥ饤
	 */
	public void setRetries(int retries) {
		this.retries = retries;
	}

	/**
	 * ॢȻ֤֤ޤ
	 * @return ॢȻ
	 */
	public int getTimeout() {
		return timeout;
	}

	/**
	 * ॢȻ֤ꤷޤ
	 * @param timeout ॢȻ
	 */
	public void setTimeout(int timeout) {
		this.timeout = timeout;
	}

	/**
	 * SNMPΥС֤ޤ
	 * @return SNMPΥС
	 */
	public int getVersion() {
		return version;
	}

	/**
	 * SNMPΥСꤷޤ
	 * @param version SNMPΥС 
	 */
	public void setVersion(int version) {
		this.version = version;
	}
}
