/*
 
Copyright (C) 2006 NTT DATA Corporation
 
This program is free software; you can redistribute it and/or
Modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation, version 2.
 
This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied 
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
PURPOSE.  See the GNU General Public License for more details.
 
*/

package com.clustercontrol.sql.dialog;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.clustercontrol.bean.MonitorConstant;
import com.clustercontrol.bean.ValidConstant;
import com.clustercontrol.bean.YesNoConstant;
import com.clustercontrol.dialog.CommonDialog;
import com.clustercontrol.dialog.ValidateResult;
import com.clustercontrol.monitor.run.bean.MonitorInfo;
import com.clustercontrol.monitor.run.bean.MonitorTypeConstant;
import com.clustercontrol.monitor.run.composite.MonitorBasicScopeComposite;
import com.clustercontrol.monitor.run.composite.MonitorRuleComposite;
import com.clustercontrol.monitor.run.composite.NumericMessageComposite;
import com.clustercontrol.monitor.run.composite.NumericRunJobComposite;
import com.clustercontrol.monitor.run.composite.NumericValueInfoComposite;
import com.clustercontrol.monitor.run.composite.StringValueInfoComposite;
import com.clustercontrol.notify.composite.NotifyInfoComposite;
import com.clustercontrol.sql.action.GetSql;
import com.clustercontrol.sql.action.GetSqlStringValueListTableDefine;
import com.clustercontrol.sql.bean.MonitorSqlInfo;
import com.clustercontrol.sql.util.JdbcDriverUtil;
import com.clustercontrol.util.Messages;

/**
 * SQLƻѹ饹Ǥ
 * 
 * @version 2.1.0
 * @since 2.0.0
 */
public class SqlCreateDialog extends CommonDialog {
	
	public static final int WIDTH_TITLE = 5;
	public static final int WIDTH_VALUE = 2;

    // ----- instance ե ----- //

    /** ͤݻ륪֥ */
    private MonitorInfo inputData = null;

    /** ͤݻ륪֥ */
    private ValidateResult validateResult = null;
    
    /** ѹоݤδƻID */
    private String monitorId = null;
    
    /** ƻܾ */
    private MonitorBasicScopeComposite m_monitorBasic = null;
    
    /** ƻ ʬ */
    private MonitorRuleComposite m_monitorRule = null;
    
    /** ³ʸ */
    private Text textUrl = null;

    /** JDBCɥ饤 */
    private Combo textJdbcDriver = null;

    /** 桼 */
    private Text textUser = null;
    
    /** ѥ */
    private Text textPassword = null;
    
    /**  */
    private Text textQuery = null;
    
    /** ʹƻȽ */
    private NumericValueInfoComposite m_numericValueInfo= null;
    
    /** ʸƻȽ */
    private StringValueInfoComposite m_stringValueInfo= null;
    
    /** ξ */
    private NotifyInfoComposite m_notifyInfo = null;
    
    /** Υå */
    private NumericMessageComposite m_notifyMessageInfo = null;
    
    /** ּ¹ @version 2.1.0 */
    private Button m_checkJobRun = null;
    
    /** ּ¹Ծ @version 2.1.0 */
    private NumericRunJobComposite m_jobRun = null;

    /** ͭˤ */
    private Button confirmValid = null;
    
	/** ƻȽ꥿ @version 2.1.0 */
	private int m_monitorType;

    // ----- 󥹥ȥ饯 ----- //

    /**
     * ѥΥ󥹥󥹤֤ޤ
     * 
     * @param parent ƤΥ륪֥
     */
    public SqlCreateDialog(Shell parent) {
        super(parent);
    }
    
    /**
     * ѥΥ󥹥󥹤֤ޤ
     * 
     * @param parent ƤΥ륪֥
     * @param monitorType ƻȽ꥿
     */
    public SqlCreateDialog(Shell parent, int monitorType) {
        super(parent);

        this.m_monitorType = monitorType;
    }

    /**
     * ѹѥΥ󥹥󥹤֤ޤ
     * 
     * @param parent ƤΥ륪֥
     * @param monitorId ѹƻID
     * @param monitorType ƻȽ꥿
     */
    public SqlCreateDialog(Shell parent, String monitorId, int monitorType) {
        super(parent);

        this.monitorId = monitorId;
        this.m_monitorType = monitorType;
    }

    // ----- instance ᥽å ----- //

    /**
     * ꥢޤ
     * 
     * @param parent
     *            ƤΥ󥹥
     */
    protected void customizeDialog(Composite parent) {
    	
        Shell shell = this.getShell();

        // ȥ
        shell.setText(Messages.getString("dialog.sql.create.modify"));

        // ѿȤѤ٥
        Label label = null;
        // ѿȤѤ륰åɥǡ
        GridData gridData = null;

        // 쥤
        GridLayout layout = new GridLayout(1, true);
        layout.marginWidth = 10;
        layout.marginHeight = 10;
        layout.numColumns = 15;
        parent.setLayout(layout);
        
        // ƻܾ
        m_monitorBasic = new MonitorBasicScopeComposite(parent, SWT.NONE);
        gridData = new GridData();
		gridData.horizontalSpan = 15;
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		m_monitorBasic.setLayoutData(gridData);
        
        /*
         * ƻ殺롼
         */
        // ٥
        label = new Label(parent, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = 15;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        label.setText(Messages.getString("monitor.rule") + " : ");
        
        // 롼
        Group groupRule = new Group(parent, SWT.NONE);
        layout = new GridLayout(1, true);
        layout.marginWidth = 5;
        layout.marginHeight = 5;
        layout.numColumns = 1;
        groupRule.setLayout(layout);
        gridData = new GridData();
        gridData.horizontalSpan = 15;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        groupRule.setLayoutData(gridData);

        m_monitorRule = new MonitorRuleComposite(groupRule, SWT.NONE);
        gridData = new GridData();
		gridData.horizontalSpan = 15;
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		m_monitorRule.setLayoutData(gridData);
        
        /*
         * å殺롼
         */
        // ٥
        label = new Label(groupRule, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = 15;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        label.setText(Messages.getString("check.rule") + " : ");
        
        // 롼
        Group groupCheckRule = new Group(groupRule, SWT.NONE);
        layout = new GridLayout(1, true);
        layout.marginWidth = 5;
        layout.marginHeight = 5;
        layout.numColumns = 15;
        groupCheckRule.setLayout(layout);
        gridData = new GridData();
        gridData.horizontalSpan = 15;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        groupCheckRule.setLayoutData(gridData);
        
        // ³ʸ
        // ٥
        label = new Label(groupCheckRule, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = WIDTH_TITLE;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        label.setText(Messages.getString("connection.url") + " : ");
        // ƥ
        this.textUrl = new Text(groupCheckRule, SWT.BORDER | SWT.LEFT);
        gridData = new GridData();
        gridData.horizontalSpan = 8;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        this.textUrl.setLayoutData(gridData);
        
        // 
        label = new Label(groupCheckRule, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = 2;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        
        // ³DB
        // ٥
        label = new Label(groupCheckRule, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = WIDTH_TITLE;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        label.setText(Messages.getString("connection.db") + " : ");
        // 
        this.textJdbcDriver = new Combo(groupCheckRule, SWT.BORDER | SWT.READ_ONLY);
        gridData = new GridData();
        gridData.horizontalSpan = 8;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        this.textJdbcDriver.setLayoutData(gridData);
        List<List> list = JdbcDriverUtil.getJdbcDriver();
        for(int i = 0; i < list.size(); i++){
        	List driver = list.get(i);
        	String name = (String)driver.get(0);
        	this.textJdbcDriver.add(name);
        }
        this.textJdbcDriver.select(0);
        
        // 
        label = new Label(groupCheckRule, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = 2;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        
        // 桼
        // ٥
        label = new Label(groupCheckRule, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = WIDTH_TITLE;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        label.setText(Messages.getString("user.id") + " : ");
        // ƥ
        this.textUser = new Text(groupCheckRule, SWT.BORDER | SWT.LEFT);
        gridData = new GridData();
        gridData.horizontalSpan = 8;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        this.textUser.setLayoutData(gridData);
        
        // 
        label = new Label(groupCheckRule, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = 2;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        
        // ѥ
        // ٥
        label = new Label(groupCheckRule, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = WIDTH_TITLE;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        label.setText(Messages.getString("password") + " : ");
        // ƥ
        this.textPassword = new Text(groupCheckRule, SWT.BORDER | SWT.LEFT | SWT.PASSWORD);
        gridData = new GridData();
        gridData.horizontalSpan = 8;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        this.textPassword.setLayoutData(gridData);
        
        // 
        label = new Label(groupCheckRule, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = 2;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        
        // SQLʸ
        // ٥
        label = new Label(groupCheckRule, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = WIDTH_TITLE;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        label.setText(Messages.getString("sql.string") + " : ");
        // ƥ
        this.textQuery= new Text(groupCheckRule, SWT.BORDER | SWT.LEFT);
        gridData = new GridData();
        gridData.horizontalSpan = 8;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        this.textQuery.setLayoutData(gridData);
        
        // 
        label = new Label(groupCheckRule, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = 2;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        
        // ʹƻξ     
		if(m_monitorType == MonitorTypeConstant.TYPE_NUMERIC){

			/*
	         * ٥롼
	         */
	        // ٥
	        label = new Label(parent, SWT.NONE);
	        gridData = new GridData();
	        gridData.horizontalSpan = 15;
	        gridData.horizontalAlignment = GridData.FILL;
	        gridData.grabExcessHorizontalSpace = true;
	        label.setLayoutData(gridData);
	        label.setText(Messages.getString("def.result") + " : ");
	        
	        // 롼
	        Group groupDefResultNode = new Group(parent, SWT.NONE);
	        layout = new GridLayout(1, true);
	        layout.marginWidth = 5;
	        layout.marginHeight = 5;
	        layout.numColumns = 1;
	        groupDefResultNode.setLayout(layout);
	        gridData = new GridData();
	        gridData.horizontalSpan = 15;
	        gridData.horizontalAlignment = GridData.FILL;
	        gridData.grabExcessHorizontalSpace = true;
	        groupDefResultNode.setLayoutData(gridData);
			
			// Ƚ
	        m_numericValueInfo = new NumericValueInfoComposite(groupDefResultNode, 
	        		SWT.NONE,
	        		true,
	        		Messages.getString("threshold.lower.limit"),
	        		Messages.getString("threshold.upper.limit"),
	        		NumericValueInfoComposite.INPUT_VERIFICATION_POSITIVE_INTEGER,
	        		Float.valueOf(0f),
	        		null);
	        gridData = new GridData();
			gridData.horizontalSpan = 1;
			gridData.horizontalAlignment = GridData.FILL;
			gridData.grabExcessHorizontalSpace = true;
			m_numericValueInfo.setLayoutData(gridData);
		}
		
		/*
         * ξ°롼
         */
        // ٥
        label = new Label(parent, SWT.NONE);
        gridData = new GridData();
        gridData.horizontalSpan = 15;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        label.setLayoutData(gridData);
        label.setText(Messages.getString("notify.attribute") + " : ");
        
        // 롼
        Group groupNotifyAttribute = new Group(parent, SWT.NONE);
        layout = new GridLayout(1, true);
        layout.marginWidth = 5;
        layout.marginHeight = 5;
        layout.numColumns = 1;
        groupNotifyAttribute.setLayout(layout);
        gridData = new GridData();
        gridData.horizontalSpan = 15;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        groupNotifyAttribute.setLayoutData(gridData);
        
        // ξIDץꥱID
		if(m_monitorType == MonitorTypeConstant.TYPE_NUMERIC){
        	this.m_notifyInfo = new NotifyInfoComposite(groupNotifyAttribute, SWT.NONE);
        }
        else if(m_monitorType == MonitorTypeConstant.TYPE_STRING){
        	this.m_notifyInfo = new NotifyInfoComposite(groupNotifyAttribute, SWT.NONE, Messages.getString("notify.id.default"));
        }
		gridData = new GridData();
		gridData.horizontalSpan = 1;
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		this.m_notifyInfo.setLayoutData(gridData);
        
		// ʹƻξ     
		if(m_monitorType == MonitorTypeConstant.TYPE_NUMERIC){
			
			// 롼
	        Group groupNotifyMessage = new Group(groupNotifyAttribute, SWT.NONE);
	        layout = new GridLayout(1, true);
	        layout.marginWidth = 5;
	        layout.marginHeight = 5;
	        layout.numColumns = 1;
	        groupNotifyMessage.setLayout(layout);
	        gridData = new GridData();
	        gridData.horizontalSpan = 1;
	        gridData.horizontalAlignment = GridData.FILL;
	        gridData.grabExcessHorizontalSpace = true;
	        groupNotifyMessage.setLayoutData(gridData);
	        
	        // ΥåʥåIDå
			this.m_notifyMessageInfo = new NumericMessageComposite(groupNotifyMessage, SWT.NONE);
			gridData = new GridData();
			gridData.horizontalSpan = 1;
			gridData.horizontalAlignment = GridData.FILL;
			gridData.grabExcessHorizontalSpace = true;
			m_notifyMessageInfo.setLayoutData(gridData);
			
			// ּ¹
	        this.m_checkJobRun = new Button(groupNotifyAttribute, SWT.CHECK);
	        gridData = new GridData();
	        gridData.horizontalSpan = 1;
	        gridData.horizontalAlignment = GridData.FILL;
	        gridData.grabExcessHorizontalSpace = true;
	        m_checkJobRun.setLayoutData(gridData);
	        m_checkJobRun.setText(Messages.getString("run") + " : ");
	        m_checkJobRun.addSelectionListener(new SelectionAdapter() {
	            public void widgetSelected(SelectionEvent e) {
	            	m_jobRun.setEnabled(m_checkJobRun.getSelection());
	            }
	        });
			
			// ּ¹ԥ롼
	        Group groupRunJob = new Group(groupNotifyAttribute, SWT.NONE);
	        layout = new GridLayout(1, true);
	        layout.marginWidth = 5;
	        layout.marginHeight = 5;
	        layout.numColumns = 1;
	        groupRunJob.setLayout(layout);
	        gridData = new GridData();
	        gridData.horizontalSpan = 15;
	        gridData.horizontalAlignment = GridData.FILL;
	        gridData.grabExcessHorizontalSpace = true;
	        groupRunJob.setLayoutData(gridData);
	        
	        // ¹ԡʼ¹ԡIDϢưƽмԻ
			this.m_jobRun = new NumericRunJobComposite(groupRunJob, SWT.NONE);
			gridData = new GridData();
			gridData.horizontalSpan = 1;
			gridData.horizontalAlignment = GridData.FILL;
			gridData.grabExcessHorizontalSpace = true;
			m_jobRun.setLayoutData(gridData);
		}
		// ʸƻξ
		else if(m_monitorType == MonitorTypeConstant.TYPE_STRING){
			
			/*
	         * ٤롼
	         */
			// ٥
	        label = new Label(parent, SWT.NONE);
	        gridData = new GridData();
	        gridData.horizontalSpan = 15;
	        gridData.horizontalAlignment = GridData.FILL;
	        gridData.grabExcessHorizontalSpace = true;
	        label.setLayoutData(gridData);
	        label.setText(Messages.getString("def.result") + " : ");
	        
	        // 롼
	        Group groupDefResult = new Group(parent, SWT.NONE);
	        layout = new GridLayout(1, true);
	        layout.marginWidth = 5;
	        layout.marginHeight = 5;
	        layout.numColumns = 1;
	        groupDefResult.setLayout(layout);
	        gridData = new GridData();
	        gridData.horizontalSpan = 15;
	        gridData.horizontalAlignment = GridData.FILL;
	        gridData.grabExcessHorizontalSpace = true;
	        groupDefResult.setLayoutData(gridData);
			
	        ArrayList tableDefine = GetSqlStringValueListTableDefine.get();
			this.m_stringValueInfo = new StringValueInfoComposite(groupDefResult, SWT.NONE, tableDefine);
			gridData = new GridData();
			gridData.horizontalSpan = 1;
			gridData.horizontalAlignment = GridData.FILL;
			gridData.grabExcessHorizontalSpace = true;
			m_stringValueInfo.setLayoutData(gridData);
		}
		
        /*
         * ̵ͭ
         */
        this.confirmValid = new Button(parent, SWT.CHECK);
        gridData = new GridData();
        gridData.horizontalSpan = 15;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        this.confirmValid.setLayoutData(gridData);
        this.confirmValid.setText(Messages.getString("setting.valid.confirmed"));
        
        // 饤
        Label line = new Label(parent, SWT.SEPARATOR | SWT.HORIZONTAL);
        gridData = new GridData();
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        gridData.horizontalSpan = 15;
        line.setLayoutData(gridData);


        // Ŭ
        // åɥ쥤ȤѤ硢ʤȲ̤äѤˤʤޤ
        shell.pack();
        shell.setSize(new Point(550, shell.getSize().y));

        // 
        Display display = shell.getDisplay();
        shell.setLocation((display.getBounds().width - shell.getSize().x) / 2,
                (display.getBounds().height - shell.getSize().y) / 2);

        // ɽ
        MonitorInfo info = null; 
        if(this.monitorId == null){
        	// ξ
        	info = new MonitorInfo();
        }
        else{
        	// ѹξ硢
        	info = new GetSql().getSql(this.monitorId, this.m_monitorType);
        }
        this.setInputData(info);
    }

    /**
     * Ƥ֤ޤ
     * 
     * @return Ƥݻξ
     */
    public MonitorInfo getInputData() {
        return this.inputData;
    }

    /**
     * ƹܤͤꤷޤ
     * 
     * @param monitor
     *            ͤȤѤƻ
     */
    protected void setInputData(MonitorInfo monitor) {

        // ƻܾ
        m_monitorBasic.setInputData(monitor);
        
        // ƻ
        m_monitorRule.setInputData(monitor);
        
        // ƻ SQLƻ
        MonitorSqlInfo sqlInfo = (MonitorSqlInfo)monitor.getCheckInfo();
        if(sqlInfo != null){
            if (sqlInfo.getConnectionUrl() != null) {
                this.textUrl.setText(sqlInfo.getConnectionUrl());
            }
            if (sqlInfo.getUser() != null) {
                this.textUser.setText(sqlInfo.getUser());
            }
            if (sqlInfo.getPassword() != null) {
                this.textPassword.setText(sqlInfo.getPassword());
            }
            if (sqlInfo.getJdbcDriver() != null) {
                List<List> list = JdbcDriverUtil.getJdbcDriver();
                for(int i = 0; i < list.size(); i++){
                	List driver = list.get(i);
                	String className = (String)driver.get(1);
                	if(className.equals(sqlInfo.getJdbcDriver())){
                		this.textJdbcDriver.setText((String)driver.get(0));
                		break;
                	}
                }
            }
            if (sqlInfo.getQuery() != null) {
                this.textQuery.setText(sqlInfo.getQuery());
            }
        }
        
        //ξ°
        if (monitor.getNotifyId() != null) {
        	this.m_notifyInfo.setText(monitor.getNotifyId());
        }
        if (monitor.getApplication() != null) {
        	this.m_notifyInfo.setApplication(monitor.getApplication());
        }
        
        // ʹƻξ     
		if(m_monitorType == MonitorTypeConstant.TYPE_NUMERIC){
			
			// ٤
	        m_numericValueInfo.setInputData(monitor);
	        
	        // Υå
	        m_notifyMessageInfo.setInputData(monitor);
	        
	        // ּ¹
	        m_checkJobRun.setSelection(YesNoConstant.typeToBoolean(monitor.getJobRun()));
	        
	        // ƽ٤Υּ¹
	        m_jobRun.setInputData(monitor);
	        m_jobRun.setEnabled(YesNoConstant.typeToBoolean(monitor.getJobRun()));
			
		}
		// ʸƻξ
		else if(m_monitorType == MonitorTypeConstant.TYPE_STRING){
			
			// ٤
	        m_stringValueInfo.setInputData(monitor);
		}
        
        // ̵ͭ
        if (monitor.getValid() == ValidConstant.TYPE_VALID) {
            this.confirmValid.setSelection(true);
        }
    }

    /**
     * ͤѤξޤ
     * 
     * @return ͤݻξ
     */
    protected MonitorInfo createInputData() {
    	MonitorInfo info = new MonitorInfo();

    	info.setMonitorTypeId(MonitorConstant.STRING_SQL);
    	info.setMonitorType(m_monitorType);
    	
    	// ƻܾ
    	validateResult = m_monitorBasic.createInputData(info);
    	if(validateResult != null){
        	return null;
        }
        
        // ƻ ʬ
        validateResult = m_monitorRule.createInputData(info);
        if(validateResult != null){
        	return null;
        }
        
        // ƻ SQLƻ
        MonitorSqlInfo sqlInfo = new MonitorSqlInfo();
        sqlInfo.setMonitorTypeId(MonitorConstant.STRING_SQL);
        sqlInfo.setMonitorId(info.getMonitorId());
        
        //³URL
        if (this.textUrl.getText() != null
                && !"".equals((this.textUrl.getText()).trim())) {
        	sqlInfo.setConnectionUrl(this.textUrl.getText());
        } else {
            this.setValidateResult(Messages.getString("message.hinemos.1"),Messages.getString("message.sql.1"));
            return null;
        }
        //桼
        if (this.textUser.getText() != null
                && !"".equals((this.textUser.getText()).trim())) {
        	sqlInfo.setUser(this.textUser.getText());
        } else {
            this.setValidateResult(Messages.getString("message.hinemos.1"),Messages.getString("message.sql.2"));
            return null;
        }
        //ѥ
        if (this.textPassword.getText() != null
                && !"".equals((this.textPassword.getText()).trim())) {
        	sqlInfo.setPassword(this.textPassword.getText());
        } else {
            this.setValidateResult(Messages.getString("message.hinemos.1"),Messages.getString("message.sql.3"));
            return null;
        }
        //SQLʸ
        if (this.textQuery.getText() != null
                && !"".equals((this.textQuery.getText()).trim())) {
        	//SELECTʸå
        	String work = this.textQuery.getText().trim();
        	if(work.length() >= 6){
        		work = work.substring(0, 6);
    			if( work.equalsIgnoreCase("SELECT")){
    				sqlInfo.setQuery(this.textQuery.getText());
    			}
    			else {
    	            this.setValidateResult(Messages.getString("message.hinemos.1"),Messages.getString("message.sql.5"));
    	            return null;
    			}
        	}
        	else{
        		this.setValidateResult(Messages.getString("message.hinemos.1"),Messages.getString("message.sql.5"));
	            return null;
        	}
        } else {
            this.setValidateResult(Messages.getString("message.hinemos.1"),Messages.getString("message.sql.4"));
            return null;
        }
        //JDBCɥ饤
        if (this.textJdbcDriver.getText() != null
                && !"".equals((this.textJdbcDriver.getText()).trim())) {
        	
            List<List> list = JdbcDriverUtil.getJdbcDriver();
            for(int i = 0; i < list.size(); i++){
            	List driver = list.get(i);
            	String name = (String)driver.get(0);
            	if(name.equals(this.textJdbcDriver.getText())){
            		sqlInfo.setJdbcDriver((String)driver.get(1));
            		break;
            	}
            }
            
            if (sqlInfo.getJdbcDriver() != null
                    && !"".equals(sqlInfo.getJdbcDriver().trim())) {
	        } else {
	            this.setValidateResult(Messages.getString("message.hinemos.1"),Messages.getString("message.sql.1"));
	            return null;
	        }
        } else {
            this.setValidateResult(Messages.getString("message.hinemos.1"),Messages.getString("message.sql.1"));
            return null;
        }
        info.setCheckInfo(sqlInfo);
        
        // ξ°
        if (this.m_notifyInfo.getText() != null
                && !"".equals((this.m_notifyInfo.getText()).trim())) {
        	info.setNotifyId(m_notifyInfo.getText());
        }
//        else{
//        	this.setValidateResult(Messages.getString("message.hinemos.1"),Messages.getString("message.monitor.9"));
//            return null;
//        }
        if (this.m_notifyInfo.getApplication() != null
                && !"".equals((this.m_notifyInfo.getApplication()).trim())) {
        	info.setApplication(m_notifyInfo.getApplication());
        }
        else{
        	if (this.m_notifyInfo.getText() != null
                    && !"".equals((this.m_notifyInfo.getText()).trim())) {
        		this.setValidateResult(Messages.getString("message.hinemos.1"),Messages.getString("message.monitor.10"));
                return null;	
        	}
        }
        
        // ʹƻξ     
		if(m_monitorType == MonitorTypeConstant.TYPE_NUMERIC){
			
			// ٤
	        validateResult = m_numericValueInfo.createInputData(info);
	        if(validateResult != null){
	        	return null;
	        }
	        
	        // Υå
	        validateResult = m_notifyMessageInfo.createInputData(info);
	        if(validateResult != null){
	        	return null;
	        }
	        
	        // ּ¹
	        info.setJobRun(YesNoConstant.booleanToType(m_checkJobRun.getSelection()));
	        
	        // ƽ٤Υּ¹
	        validateResult = m_jobRun.createInputData(info);
	        if(validateResult != null){
	        	return null;
	        }
		}
		// ʸƻξ
		else if(m_monitorType == MonitorTypeConstant.TYPE_STRING){
			
			// ٤
	        validateResult = m_stringValueInfo.createInputData(info);
	        if(validateResult != null){
	        	return null;
	        }
	        
	        // ٤IDꤵƤ
	        if(m_stringValueInfo.isNotify()){
	        	if (this.m_notifyInfo.getApplication() == null
	                    || "".equals((this.m_notifyInfo.getApplication()).trim())) {
	            	this.setValidateResult(Messages.getString("message.hinemos.1"),Messages.getString("message.monitor.10"));
	                return null;
	            }
	        }
	        
	        // ּ¹
	        info.setJobRun(YesNoConstant.TYPE_YES);
		}
        
        // ͭ/̵
        if (this.confirmValid.getSelection()) {
        	info.setValid(ValidConstant.TYPE_VALID);
        } else {
        	info.setValid(ValidConstant.TYPE_INVALID);
        }

        return info;
    }

    /**
     * ͥå򤷤ޤ
     * 
     * @return ڷ
     */
    protected ValidateResult validate() {
        // 
        this.inputData = this.createInputData();

        if (this.inputData != null) {
            return super.validate();
        } else {
            return validateResult;
        }
    }

    /**
     * ϣ˥ܥΥƥȤ֤ޤ
     * 
     * @return ϣ˥ܥΥƥ
     */
    protected String getOkButtonText() {
        return Messages.getString("ok");
    }

    /**
     * 󥻥ܥΥƥȤ֤ޤ
     * 
     * @return 󥻥ܥΥƥ
     */
    protected String getCancelButtonText() {
        return Messages.getString("cancel");
    }
    
    /**
     * ̵ͤξꤷޤ
     *  
     */
    private void setValidateResult(String id, String message) {

        this.validateResult = new ValidateResult();
        this.validateResult.setValid(false);
        this.validateResult.setID(id);
        this.validateResult.setMessage(message);
    }
}